
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>canvas 中save和restore的用法 / 憋错料</title>

    <meta name="description" content="canvas 中save和restore的用法 在创建新的控件或修改现有的控件时,我们都会涉及到重写控件或View的onDraw方法. onDraw方法会传入一个Canvas对象,它是你用来绘制控件视觉界面的画布. 在onDraw方法里,我们经常会看到调用save和restore方法,它们到底是干什么用的呢? ? save:用来保存Canvas的状态.save之后,可以调用Canvas的平移.放缩.旋转.错切.裁剪等操作. ? restore:用来恢复Canvas之前保存的状态.防止save后对Canvas执行的操作对后续的绘制有影响. sa">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">canvas 中save和restore的用法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在创建新的控件或修改现有的控件时，我们都会涉及到重写控件或View的onDraw方法。</p>
<p>onDraw方法会传入一个Canvas对象，它是你用来绘制控件视觉界面的画布。</p>
<p>在onDraw方法里，我们经常会看到调用save和restore方法，它们到底是干什么用的呢？</p>
<p>?&nbsp;save：用来保存Canvas的状态。save之后，可以调用Canvas的平移、放缩、旋转、错切、裁剪等操作。</p>
<p>?&nbsp;restore：用来恢复Canvas之前保存的状态。防止save后对Canvas执行的操作对后续的绘制有影响。</p>
<p>save和restore要配对使用（restore可以比save少，但不能多），如果restore调用次数比save多，会引发Error。</p>
<p>例如：我们先想在画布上绘制一个右向的三角箭头，当然，我们可以直接绘制，另外，我们也可以先把画布旋转90&deg;，画一个向上的箭头，然后再旋转回来（这种旋转操作对于画圆周上的标记非常有用）。然后，我们想在右下角有个20像素的圆，那么，onDraw中的核心代码是：</p>
<p>int px = getMeasuredWidth();</p>
<p>int py = getMeasuredWidth();</p>
<p>// Draw background</p>
<p>canvas.drawRect(0, 0, px, py, backgroundPaint);</p>
<p>canvas.save();</p>
<p>canvas.rotate(90, px/2, py/2);</p>
<p>// Draw up arrow</p>
<p>canvas.drawLine(px / 2, 0, 0, py / 2, linePaint);</p>
<p>canvas.drawLine(px / 2, 0, px, py / 2, linePaint);</p>
<p>canvas.drawLine(px / 2, 0, px / 2, py, linePaint);</p>
<p>canvas.restore();</p>
<p>// Draw circle</p>
<p>canvas.drawCircle(px - 10, py - 10, 10, linePaint);</p>
<p>效果如图1所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3hpcmloYW5saW4vc2F2ZXJlc3RvcmUxLlBORw==.jpg" /></p>
<p>图1</p>
<p>如果我们不调用save和restore会是什么样子呢？如图2所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL2NuYmxvZ3NfY29tL3hpcmloYW5saW4vc2F2ZXJlc3RvcmUyLlBORw==.jpg" /></p>
<p>图2</p>
<p>从这两个图中，我们就能看到圆圈位置的明显差异。不进行Canvas的save和restore操作的话，所有的图像都是在画布旋转90&deg;后的画布上绘制的。当执行完onDraw方法，系统自动将画布恢复回来。save和restore操作执行的时机不同，就能造成绘制的图形不同。</p>
<p>所以，save和restore之间，往往夹杂的是对Canvas的特殊操作。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 05:31:11 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>canvas 中save和restore的用法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k95K74.html" rel="bookmark">HTML5中canvas的save和restore方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				canvas的save和restore方法: save() 方法把当前绘画状态的一份拷贝压入到一个保存图像状态的栈中.这里的绘画状态指坐标原点.变形时的变化矩阵(该矩阵是调用 rotate().scale() 和 translate() 的结果).以及图形上下文对象的当前属性值等内容. 1.图像上下文CanvasRenderingContext2D的属性和方法: 属性                              描述canvas                          取			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZbXeq3.html" rel="bookmark">Canvas的save和restore</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在创建新的控件或修改现有的控件时,我们都会涉及到重写控件或View的onDraw方法. onDraw方法会传入一个Canvas对象,它是你用来绘制控件视觉界面的画布. 在onDraw方法里,我们经常会看到调用save和restore方法,它们到底是干什么用的呢? ? save:用来保存Canvas的状态.save之后,可以调用Canvas的平移.放缩.旋转.错切.裁剪等操作. ? restore:用来恢复Canvas之前保存的状态.防止save后对Canvas执行的操作对后续的绘制有影响. sa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4plqJw4.html" rel="bookmark">android&lowbar;浅析canvas的save&lpar;&rpar;和restore&lpar;&rpar;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[java] view plain copy &lt;span style=&quot;font-size:18px;&quot;&gt; &lt;/span&gt; [java] view plain copy &lt;span style=&quot;font-size:18px;&quot;&gt;&lt;/span&gt; 绘图之前,首先需要调整画笔,待画笔调整好之后,再将图像绘制到画布上,这样才可以显示在手机屏幕上!Android 中的画笔是 Paint类,Paint 中包含了很多方法对其属性进			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wRdnV0.html" rel="bookmark">HTML5 canvas 中的arcTo&lpar;&rpar;方法的用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				除了arc()之外,Canvas的绘图环境对象还提供了另一个用于创建圆弧路径的方法,那就是arcTo().改方法接受了5个参数: arcTo(x1,x2,y1,y2,radius) arcTo()方法的参数分别代表两个点击圆形半径.该方法一指定的半径来绘制一条圆弧,此圆弧与当前点到第一个点(x1,y1)的连线相切,而且第一个点到第二点(x2,y2)的连线也相切.该方法的这些特性,使得它非常适合用了绘制矩形的原角. 使用arcTo()方法: html: &lt;!Doctyp html&gt; &lt;ht			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzjBJkM.html" rel="bookmark">YII框架中save&lpar;&rpar;和insert&lpar;&rpar;的用法差异</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				要了解YII框架中save()和insert()的用法差异,首先查看一下手册中关于两个方法的定义: http://www.yiichina.com/api/CActiveRecord#save-detail save() 方法 源码: framework/db/ar/CActiveRecord.php#784 保存当前的记录. 插入记录到数据表的一行, 如果它的isNewRecord属性为true(通常情况下使用的‘new’运算符来创建记录). 否则, 将被用于更新表中的相应行(通常情况下,使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47EAKk0.html" rel="bookmark">Canvas的save和restore简单程序说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于save和restore网上不少说明,在这里简单的用程序证实了一下. 图1 上图为绘制的最终图画,绘制这种view有多中方式. a) 简单的方式:不对canvas进行任何平移或者旋转的操作,对canvas直接绘制.代码如下 @Override protected void onDraw(Canvas canvas) { int width = 900; int height = 900; Paint paint = new Paint(); //上半部分红色举行 paint.setColor			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ap6pJM.html" rel="bookmark">理解Canvas的save&lpar;&rpar;和restore&lpar;&rpar;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				save()和restore()方法是绘制复杂图形必不可少的方法.它们分别是用来保存和恢复 canvas 状态的,都没有参数. Canvas 状态是以堆(stack)的方式保存的,每一次调用 save 方法,当前的状态就会被推入堆中保存起来.这种状态包括:当前应用的变形(即移动,旋转和缩放,见下):strokeStyle, fillStyle, globalAlpha, lineWidth, lineCap, lineJoin, miterLimit, shadowOffsetX,shadowO			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O2yBZ0.html" rel="bookmark">Android 中Canvas的save&lpar;&rpar;&comma;saveLayer&lpar;&rpar;和restore&lpar;&rpar;解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.save()方法 : 用来保存Canvas的状态,save()方法之后的代码,可以调用Canvas的平移.放缩.旋转.裁剪等操作! 2.restore()方法: 用来恢复Canvas之前保存的状态(可以想成是保存坐标轴的状态),防止save()方法代码之后对Canvas执行的操作,继续对后续的绘制会产生影响,通过该方法可以避免连带的影响 总结:就是在save之前绘制的状态会保存下来,在restore方法之后绘制的不会再因为状态而改变 示例说明: 例如:我们想在画布上绘制一个向右的三角箭头,当			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm7rDn3.html" rel="bookmark">Android Canvas的save&lpar;&rpar;&comma;saveLayer&lpar;&rpar;和restore&lpar;&rpar;浅谈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				save()  saveLayer()  restore() 1.在自定义控件当中你onMeasure和onLayout的工作做完成以后就该绘制该控件了,有时候需要自己在控件上添加一些修饰来满足需求 复写onDraw(Canvas canvas),其中Canvas就像是一块画布,你自定义控件的样式就是在它上面完成的. Canvas ,Paint等基本概念就不赘述了. 2.下面就直接用demo来解释标题列出的方法先介绍save()和 必须了解的相关知识:http://www.cnblogs.com			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V02jxA0.html" rel="bookmark" class="title">Java 并发编程 - 3</a>
					<div>
						JDK 1.5 之前的同步容器 JDK 1.5 之前, 主要包括: 同步容器 (Vector 和 Hashtable) 同步包装类 (Collections.synchronizedXxx) 这些类的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXX28M.html" rel="bookmark" class="title">关于PM（项目经理）的思考和课后问题解答</a>
					<div>
						这次我要说明的是关于两个关于PM的问题.这里的PM专指我们的软件项目经理,所以这次我们需要从一个更高的角度去看这个问题,假设你可以作为一个团队的领导者和你的团队一同进行软件的设计,同时还需要完成在开发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWl9l0.html" rel="bookmark" class="title">Codeforces&lowbar;844</a>
					<div>
						A.统计字母个数. #include&lt;bits/stdc++.h&gt; using namespace std; string s; int n; map&lt;char,int&gt; mp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49brgbM.html" rel="bookmark" class="title">Eclipse中web项目部署至Tomcat步骤</a>
					<div>
						Eclipse的web工程至Tomcat默认的部署目录是在工程空间下,本文旨在将部署目录改为Tomcat安装目录,并解决依赖包输出问题. 1.在Eclipse中添加Tomcat服务器. 2.将web工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nEY9pM.html" rel="bookmark" class="title">centos定时计划任务</a>
					<div>
						任务调度的crond常驻命令crond 是linux用来定期执行程序的命令.当安装完成操作系统之后,默认便会启动此任务调度命令.crond命令每分锺会定期检查是否有要执行的工作,如果有要执行的工作便会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXeOX3.html" rel="bookmark" class="title">Struts2使用JSON插件实现异步刷新功能</a>
					<div>
						1.说起这个Json插件实现异步刷新的功能折腾了我两天了,本想使用Juery来实现,可是在Jsp页面中始终无法获取json数据,最终无奈之下只能选择了最原始的方式. 2.首先是需要加载struts2- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7wEX3.html" rel="bookmark" class="title">CSU OJ 1120 病毒（湖南省第八届大学生计算机程序设计竞赛）</a>
					<div>
						﻿﻿ 1120: 病毒 Time Limit: 3 Sec  Memory Limit: 128 MB Submit: 146  Solved: 53 [Submit][Status][Web Boa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K2gNrM.html" rel="bookmark" class="title">WinForm界面布局</a>
					<div>
						一直很羡慕和佩服园子中伍华聪的界面设计和布局.好多年都没有真正写过C/S项目了,今天翻出来6年前刚开始学习WinForm的时候写的一个简单的HR管理系统,思绪一下子很复杂,记得是6年前的夏天,天气很热 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lGy6BM.html" rel="bookmark" class="title">Add Two Numbers Leetcode</a>
					<div>
						You are given two non-empty linked lists representing two non-negative integers. The digits are stor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDDGnM.html" rel="bookmark" class="title">中期项目总结</a>
					<div>
						1.前端的步骤 webroot (css,doc,images,js,member,My97DatePicker(表单里的日历插件),sql,util)web-inf 里边的web.xml lib里边 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGPkZQ0.html" rel="bookmark" class="title">UITextField的returnkey点击事件</a>
					<div>
						关于隐藏软键盘,网上的办法良莠不齐,大多是通过实现UITextFieldDelegate来隐藏软键盘,该方法代码较多,且在文本框很多的时不好处理.我经过搜索与摸索,找到了最佳的处理办法.(引用的)一. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvvv73.html" rel="bookmark" class="title">java笔试浅谈</a>
					<div>
						从第一份笔试到现在已经有差不多一个月了,记得自己第一份笔试就是腾讯的.那时就是抱着量力而为的心情去参加的,果然,整份试题有不少知识自己是没见过的,有一些知识是学过但忘记了的,所以,那次笔试就是去做&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQYkoM.html" rel="bookmark" class="title">c&plus;&plus;常用函数STL</a>
					<div>
						完c++快一年了,感觉很有遗憾,因为一直没有感觉到c++的强大之处,当时最大的感觉就是这个东西的输入输出比C语言要简单好写. 后来我发现了qt,opencv,opengl,原来,c++好玩的狠. 在这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODqL84.html" rel="bookmark" class="title">DLL中建立进程共享数据段需要注意的语法问题</a>
					<div>
						默认情况下,所有的数据段都是进程独立的,每个进程有自己的一份.但有时候进程共享一个数据段也是有需要的,为此VC++编译连接器提供了专门的语法,下面是一个典型的例子,建立了一个名为Shared的共享数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q7WpQ0.html" rel="bookmark" class="title">设置铃声</a>
					<div>
						1.权限 &lt;uses-permission android:name=&quot;android.permission.MOUNT_UNMOUNT_FILESYSTEMS&quot;/&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbKDq3.html" rel="bookmark" class="title">第九周项目3-输出星号图</a>
					<div>
						a: /* *Copyright (c) 2014,烟台大学计算机学院 *All gight reserved. *文件名称:temp.cpp *作者:邵帅 *完成时间:2014年10月22日 *版本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9Q1z4.html" rel="bookmark" class="title">HDU - 2553 ：N皇后问题</a>
					<div>
						在N*N的方格棋盘放置了N个皇后,使得它们不相互攻击(即任意2个皇后不允许处在同一排,同一列,也不允许处在与棋盘边框成45角的斜线上. 你的任务是,对于给定的N,求出有多少种合法的放置方法. Inpu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezb8D3.html" rel="bookmark" class="title">result结果集</a>
					<div>
						结果集(ResultSet)是数据中查询结果返回的一种对象,可以说结果集是一个存储查询结果的对象,但是结果集并不仅仅具有存储的功能,他同时还具有操纵数据的功能,可能完成对数据的更新等. 结果集读取数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgR6wN4.html" rel="bookmark" class="title">zoj1425解题报告</a>
					<div>
						刚开始题目意思理解错了,以为一个匹配允许被多个匹配交叉,然后取一个匹配满足条件即可.于是错了. 如:1 3 2 4 2 4 1 3 的答案应该是2而不是4.一个匹配只能允许被有且只有一个匹配交叉. 那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YQXvy0.html" rel="bookmark" class="title">训练1：删除序列中相同的数</a>
					<div>
						题目要求: 有16个数{1,2,2,3,4,4,5,6,6,7,8,8,8,9,10,10},已经按由大到小顺序排好,存储在数组a中 试建立一个类ARR,完成删除数组中相同的数,经过删除后,数组中的内 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
